//
//  Text.m
//  Demine
//
//  Created by Michael Heyeck on 4/10/10.
//  Copyright 2010 Fair Oaks Labs, Inc.. All rights reserved.
//

#import "Text.h"


@implementation Text

@synthesize drawMode;
@synthesize strokeWidth;
@synthesize font;
@synthesize color;
@synthesize offset;
@synthesize string;


- (id)copyWithZone:(NSZone*)zone
{
	Text* copy = [super copyWithZone:zone];
	
	copy->drawMode		= drawMode;
	copy->strokeWidth	= strokeWidth;
	copy->font			= [font retain];
	copy->color			= [color retain];
	copy->offset		= offset;
	copy->string		= [string retain];
	
	return copy;
}


- (void)renderToContext:(CGContextRef)context
{
	CGContextSetTextDrawingMode(context, drawMode);
	CGContextSetLineWidth(context, strokeWidth);
	CGContextSelectFont(context, [[font fontName] cStringUsingEncoding:NSASCIIStringEncoding], [font pointSize], kCGEncodingMacRoman);
	[color set];
	
	CGContextShowTextAtPoint(context,
							 offset.x,
							 offset.y + [font pointSize],
							 [string cStringUsingEncoding:NSMacOSRomanStringEncoding],
							 [string lengthOfBytesUsingEncoding:NSMacOSRomanStringEncoding]);
}


- (void)dealloc
{
	[font release];
	[color release];
	[string release];
    [super dealloc];
}

@end
